//    KSH-148   LPT
//      I2C (  )
// I2C SOFT LPT_bit0(pin2)=I2c_Clk LPT_bit1[pin3)=I2C_Data
//    LPT   XP,  inpout32.dll
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls;

 function Inp32(PortAdr: word): byte; stdcall; external 'inpout32.dll';
 function Out32(PortAdr: word; Data: byte): byte; stdcall; external 'inpout32.dll';

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    TrackBar1: TTrackBar;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Label10: TLabel;
    procedure TrackBar1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  tuner_step,tuner_if,tuner_vco,tuner_hi,tuner_lo,Tuner_band: integer;
  port,data,tmp:  integer;
  buster: integer;
  implementation

{$R *.dfm}

Function st(tmp:byte):byte;
    begin
      st:=255;
      if  tmp=0 then st:=1;  if  tmp=1 then st:=2;  if  tmp=2 then st:=4;
      if  tmp=3 then st:=8;  if  tmp=4 then st:=16; if  tmp=5 then st:=32;
      if  tmp=6 then st:=64; if  tmp=7 then st:=128;
     end;

Function i2c_del:boolean; var tc: integer; begin tc:=0; while tc<100000 do begin inc(tc); end; i2c_del:=true; end;
Function i2c_start:byte; begin Out32(port, $03); i2c_del; Out32(Port, $01); i2c_del; Out32(Port, $00); i2c_del; i2c_start:=0; end;
Function i2c_stop:byte; begin Out32(Port, $01); i2c_del; Out32(Port, $03); i2c_del; i2c_stop:=0; end;

Function i2c_byte:byte; //     I2C
  var
    i:  integer;
  begin
  for i:=0 to 7 do begin
  tmp:=i;
  if (data and st(7-i))=st(7-i) then begin
  Out32(Port, $02); i2c_del; Out32(Port, $03); i2c_del; Out32(port,$02); i2c_del;
  end
  else
    begin
     Out32(Port, $00); i2c_del; Out32(Port, $01); i2c_del; Out32(port,$00); i2c_del;
    end;
   end;
  Out32(Port, $00); i2c_del; Out32(Port, $01); i2c_del; Out32(port,$02); //i2c_del;
  i2c_byte:=0;
end;

function tuner_i2c:boolean; //     I2C
  begin
                    i2c_start;
  data:=$c0;        i2c_byte;   //c2
  data:=tuner_hi;   i2c_byte;   //hi
  data:=tuner_lo;   i2c_byte;   //lo
  data:=$ca;                    //     +20
  if buster=1 then data:=$cb;
                    i2c_byte;
  data:=tuner_band; i2c_byte;   //band
//                  i2c_stop;
  tuner_i2c:=true;
  end;


procedure TForm1.FormCreate(Sender: TObject);
begin
port:=$378; //   LPT1 
tuner_step:=31250; //       (31250,62500,125000 ...)
tuner_if:=36000000; //     
Out32(port,0); buster:=-1; tuner_band:=$01;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
tuner_vco:=tuner_step*(Form1.TrackBar1.Position);
Tuner_band:=$01;
If tuner_vco-Tuner_if>155000000 then tuner_band:=$02;
If tuner_vco-Tuner_if>440000000 then tuner_band:=$0c;
tuner_hi:=Trunc(tuner_vco/tuner_step/256);
tuner_lo:=Trunc(Tuner_Vco/tuner_step-tuner_hi*256);

Form1.Label1.Caption:=' '+FloatToStr(tuner_vco/1000);
Form1.Label2.Caption:=' '+FloatToStr(tuner_if/1000);
Form1.Label3.Caption:=' '+FloatToStr((tuner_vco-tuner_if)/1000);
Form1.Label4.Caption:='BAND='+IntToHex(tuner_band,2);
Form1.Label8.Caption:='Hi byte:='+IntToHex(tuner_hi,2);
Form1.Label9.Caption:='Lo byte:='+IntToHex(tuner_lo,2);
tuner_i2c;
end;


procedure TForm1.Button1Click(Sender: TObject);
begin
tuner_vco:=145500000+tuner_if;
Form1.TrackBar1.Position:=Trunc(tuner_vco/tuner_step);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
tuner_vco:=435500000+tuner_if;
Form1.TrackBar1.Position:=Trunc(tuner_vco/tuner_step);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
buster:=-buster; tuner_i2c;
if buster=1 then form1.Label10.Caption:='IF-1(out)=0,0db';
if buster=-1 then form1.Label10.Caption:='IF-1(out)=+20db';
end;

end.

//    ,     
//  (clk,data)   KSH148,     .

